#!/bin/sh

flow_sources="\
/opt/flows.192.168.3.248 \
/opt/flows.192.168.3.250 \
/opt/flows.192.168.4.10 \
/opt/flows.PE\
"

bg_prefix="/opt/BGBillingData"
bg_loader="/usr/local/BGIPNetflowCollector/netflow.sh"

my_name=`dirname $0`/`basename $0 | awk -F. '{print $1}'`
bg_converter=$my_name.bin
LOG=$my_name.log

echo -n "Started $0 withh pid=$$ at " >>$LOG
date >>$LOG
echo Working on file $1 >>$LOG

load_date=`basename $1 | awk -F. '{print $2}' | awk -F- '{print $1"."$2"."$3}'`
load_time=`basename $1 | awk -F. '{print $3}' | awk '{print substr($1, 1, 2) ":" substr($1, 3, 2)}'`
year=`echo $load_date | awk -F. '{print $1}'`
mon=`echo $load_date | awk -F. '{print $2}'`
day=`echo $load_date | awk -F. '{print $3}'`
hour=`echo $load_time | awk -F: '{print $1}'`
min=`echo $load_time | awk -F: '{print $2}'`

if [ ! $min -eq "45" ]
then
    echo "*** Nothing to to 'cause working time is not reached ($1)" >>$LOG
    exit
fi

sources=`$bg_loader sourcelist`

cmd_convert=""

for i in `echo $sources | sed 'y/;/\n/'`
do
    address=`echo $i | awk -F: '{print $1}'`
    source_id=`echo $i | awk -F: '{print $2}'`

    cur_dir="$bg_prefix/source_$source_id/$year/$mon/$day"

    [ ! -d $cur_dir ] ; mkdir -p $cur_dir

    cmd_convert="$cmd_convert $cur_dir/log_$hour $address "
done

filelist=""

for i in `echo $flow_sources`
do
    cfile=`ls $i/$year/$year-$mon/$year-$mon-$day/ft-v05.$year-$mon-$day.$hour*`
    filelist="$cfile $filelist"
done

echo $bg_converter $cmd_convert sb $filelist >>$LOG
$bg_converter $cmd_convert sb $filelist >>$LOG

for i in `echo $sources | sed 'y/;/\n/'`
do
    source_id=`echo $i | awk -F: '{print $2}'`
    echo $bg_loader isload $source_id $year-$mon-$day-$hour >>$LOG
    $bg_loader isload $source_id $year-$mon-$day-$hour >>$LOG
done

echo -n "Finished $0 with pid=$$ at " >>$LOG
date >>$LOG
