//   flow-tools
#include <iostream>
#include <cstring>
#include <stdlib.h>
#include <fstream>
#include <deque>
	
//#define dbg 1
//#pragma pack(1)	
	
extern "C"
    {
    #include "ftlib.h"
    }
    

using namespace std;

typedef struct
	{
	FILE* fp;
	unsigned long router;
	char* dest_file;
	unsigned long lines_count;
	} res_st;
	

struct options 
    {
    char dbaseURI[256];
    u_int32 cflowd_mask;
    u_int64 ft_mask;
    u_long records;
    };
#pragma pack(1)
typedef struct
	{
	unsigned long fromAddr;
	unsigned long toAddr;
    short int fromIface;
    short int toIface;
    short int fromPort;
    short int toPort;
    unsigned long amount;	
	} bitel;
//#pragma pack(pop)
	

void inet_ntoa_be(unsigned long addr,char* buf)
    {
    int i = 0;
    memset(buf,15,0);
    char sb[6] = "";
    for (;i < 4; i++)
        {
        sprintf(sb,"%i",(int)((addr >> (3-i)*8) & 0xFF));
        if (i != 0)
            {
            strcat(buf,".");    
            }
        strcat(buf,sb);
        }    
    }
    
unsigned long inet_aton_be(char* source)
    {
    unsigned long res = 0;
    char* sp = source;
    char* p = source;
    char res_buf[4] = "";
    int len = 0;
    int pos = 3;
    while(*p != 0)
        {
        if (pos > 0)
            {
            if (*p == '.') 
                {
                memset(res_buf,0,4);
                strncpy(res_buf,sp,len);
                res += (atoi(res_buf) << pos*8);
                p++;
                len = 0;
                sp = p;
                pos--;
                continue;
                }               
            } else
                {
                memset(res_buf,0,4);
                strncpy(res_buf,sp,strlen(sp));
                res += atoi(res_buf);
                break;
                }
        len++;
        p++;    
        }
    return res;
	}

/* parameters
dstfile router_ip [dstfile router] sb srcfile [srcfile..]	
*/
main(int argc, char* argv[])
    {
    int i =0;
    int start_index = 0;
    bool flag = false;
    for	(;i < argc; i++)
    	{
    	if (strcmp(argv[i],"sb") == 0)
    		{
    		start_index = i+1;
    		flag = true;
    		break;
    		}
    	}
    
    if (!flag)
    	{
    	cerr << "Delimeter character not found in param list, delimeter: sb" << endl;
    	return(1);
    	}
    
    deque<res_st*> res_queue;
    deque<res_st*>::iterator p;
    i = 1;
    res_st* rs;
    while (i < (start_index - 1))
    	{
   		rs = new res_st;
   		memset(rs,0,sizeof(res_st));
   		#ifdef dbg
   			cout << argv[i] << endl;
   		#endif
   		rs->dest_file = argv[i];
   		rs->fp = fopen(argv[i],"wb");
   		if (!(rs->fp))
  			{
   			cerr << "Unable to create file " << argv[i] << endl;
   			delete rs;
   			} else
   				{
   				rs->router = inet_aton_be(argv[i+1]);
   				res_queue.push_back(rs);
   				}
   		i++;
   		i++;    				
    	}	
    	
    if (res_queue.size() == 0)
    	{
    	cerr << "Error in param list" << endl;
    	return(1);
    	}
   
   	int fd = 0;
   	int zv_count = 0;
   	int str_count = 0;
   	FILE* fp;
   	i = start_index;
    while (i < argc)
    	{
		if ((fp = fopen(argv[i],"rb"))==NULL) 
	    	{
	    	cerr << "Cannot open file " << argv[i] << endl;
	    	i++;
	    	continue;
	    	}
    	cout << "Work on file " << argv[i] << endl;
		fd = fileno(fp);
		
		struct ftio ftio;
		struct ftprof ftp;
		struct options opt;
		
		/* init fterr */
		fterr_setid(argv[0]);
		bzero(&opt, sizeof opt);
		opt.cflowd_mask = 0xFFFFFFFFL;
		opt.ft_mask = 0xFFFFFFFFFFFFFFFFLL;
					
	 	/* profile */
		ftprof_start (&ftp);
		if (ftio_init(&ftio, fd, FT_IO_FLAG_READ) < 0)
	   		{
	    	cerr << "Error in initialization ftio structure" << endl;
	    	return 0;
	    	}
	
		struct fts3rec_offsets fo;
		struct ftver ftv;
		void *rec;
		int len;
		u_int32 data;

		ftio_get_ver(&ftio, &ftv);
		fts3rec_compute_offsets(&fo, &ftv);
		bitel b_rec;
		#ifdef dbg
			int dbg_indx = 0;
		#endif
		while (rec = ftio_read(&ftio)) 
  			{
  			str_count++;
  			p = res_queue.begin();
  			while (p != res_queue.end())
  				{
  				if ((*((u_int32*)((char*)rec+(&fo)->exaddr))) == (*p)->router)
  					{
  					b_rec.fromAddr = ((*((u_int32*)((char*)rec+(&fo)->srcaddr))) >> 24) + 
									(((*((u_int32*)((char*)rec+(&fo)->srcaddr))) & 0xFF) << 24) + 
									(((*((u_int32*)((char*)rec+(&fo)->srcaddr))) >> 8) & 0xFF00) + 
									(((*((u_int32*)((char*)rec+(&fo)->srcaddr))) & 0xFF00) << 8);
					
					b_rec.toAddr = ((*((u_int32*)((char*)rec+(&fo)->dstaddr))) >> 24) + 
									(((*((u_int32*)((char*)rec+(&fo)->dstaddr))) & 0xFF) << 24) + 
									(((*((u_int32*)((char*)rec+(&fo)->dstaddr))) >> 8) & 0xFF00) + 
									(((*((u_int32*)((char*)rec+(&fo)->dstaddr))) & 0xFF00) << 8);
					
					b_rec.fromIface = 	*((u_int32*)((char*)rec+(&fo)->input));
					b_rec.toIface = 	*((u_int32*)((char*)rec+(&fo)->output));
					#ifndef dbg
					b_rec.fromIface = (b_rec.fromIface >> 8) + ((b_rec.fromIface << 8) & 0xFF00);
					b_rec.toIface = (b_rec.toIface >> 8) + ((b_rec.toIface << 8) & 0xFF00);
					#endif
					
					
					/* (((*((u_int32*)((char*)rec+(&fo)->input))) >> 8) & 0xFF00); 
									+
									(((*((u_int32*)((char*)rec+(&fo)->input))) << 8) & 0xFF00);
									
					
					b_rec.toIface = (((*((u_int32*)((char*)rec+(&fo)->output))) >> 8) & 0xFF00); 
									+ 
									(((*((u_int32*)((char*)rec+(&fo)->output))) << 8) & 0xFF00);
					*/			
					b_rec.fromPort = *((u_int32*)((char*)rec+(&fo)->srcport));
					b_rec.toPort = *((u_int32*)((char*)rec+(&fo)->dstport));
					b_rec.fromPort = (b_rec.fromPort >> 8) + ((b_rec.fromPort << 8) & 0xFF00);
					b_rec.toPort = (b_rec.toPort >> 8) + ((b_rec.toPort << 8) & 0xFF00);
					
					/*	(((*((u_int32*)((char*)rec+(&fo)->srcport))) >> 8) & 0xFF00) + 
									(((*((u_int32*)((char*)rec+(&fo)->srcport))) & 0xFF) << 8);
					
					b_rec.toPort = (((*((u_int32*)((char*)rec+(&fo)->dstport))) >> 8) & 0xFF00) + 
									(((*((u_int32*)((char*)rec+(&fo)->dstport))) & 0xFF) << 8);
					*/
    				b_rec.amount = ((*((u_int32*)((char*)rec+(&fo)->dOctets))) >> 24) + 
									(((*((u_int32*)((char*)rec+(&fo)->dOctets))) & 0xFF) << 24) + 
									(((*((u_int32*)((char*)rec+(&fo)->dOctets))) >> 8) & 0xFF00) + 
									(((*((u_int32*)((char*)rec+(&fo)->dOctets))) & 0xFF00) << 8);
					fwrite(&b_rec,sizeof(bitel),1,(*p)->fp);
					(*p)->lines_count++;
					#ifdef dbg
						if (dbg_indx < 10)
							{
								
							//printf("res from %i/%i \n",
							cout << b_rec.toIface << " " << b_rec.fromIface << endl;
							//cout << *((u_int32*)((char*)rec+(&fo)->input)) << " " << *((u_int32*)((char*)rec+(&fo)->output)) << endl;
							//printf("res from %X/%x to %X/%x\n",b_rec.fromPort,*((u_int16*)((char*)rec+(&fo)->srcport)),b_rec.toPort,*((u_int16*)((char*)rec+(&fo)->dstport)));
							//printf("src from %X to %X\n",*((u_int32*)((char*)rec+(&fo)->input)),*((u_int32*)((char*)rec+(&fo)->output)));
							//cout << *((u_int32*)((char*)rec+(&fo)->input)) << " " << *((u_int32*)((char*)rec+(&fo)->output)) << endl; 
							dbg_indx++;
							}
					#endif
  					break;
  					}
  				p++;
  				}
			++opt.records;
  			} 
  		ftio_close(&ftio);
		fclose(fp);
		i++;
		}
		p = res_queue.begin();
		while (p != res_queue.end())
			{
			fclose((*p)->fp);
			cout << "Lines in " << (*p)->dest_file << ": " << (*p)->lines_count << endl;
			delete (*p);
			p++;
			}
		cout << "Total lines: " << str_count << endl;
return 0;
}
